define robot position
(
	# actual size
	size [0.33 0.33 0.075]
	# center of rotation offset, none with respect to the geometric center of the robot
	origin [0.0 0.0 0 0]

	# This block approximates a circular shape of a Robot
	block
	(
		points 16
		point[0] [ 0.225 0.000 ]
		point[1] [ 0.208 0.086 ]
		point[2] [ 0.159 0.159 ]
		point[3] [ 0.086 0.208 ]
		point[4] [ 0.000 0.225 ]
		point[5] [ -0.086 0.208 ]
		point[6] [ -0.159 0.159 ]
		point[7] [ -0.208 0.086 ]
		point[8] [ -0.225 0.000 ]
		point[9] [ -0.208 -0.086 ]
		point[10] [ -0.159 -0.159 ]
		point[11] [ -0.086 -0.208 ]
		point[12] [ -0.000 -0.225 ]
		point[13] [ 0.086 -0.208 ]
		point[14] [ 0.159 -0.159 ]
		point[15] [ 0.208 -0.086 ]
		z [ 0 0.075 ]
	)
	
	color "gray50"
	# where the hokuyo is placed on the robot
	hokuyo( pose [0 0 0 0] )
	
	gui_nose 1

	drive "diff"
	
	# Start odometry at (0, 0, 0)
	# localization_origin [ 0 0 0 0 ]
	
	# Report error-free position in world coordinates
	# localization "gps"
	
	# Alternative odometric localization with simple error model
	# Change to "gps" to have impossibly perfect, global odometry
	# localization "odom"
	# Odometry error or slip in X, Y, Z and Theta
	# odom_error [0.03 0.03 0.00 0.05]

)


